unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, AbBase, AbBrowse, AbZBrows, AbZipper, AbArcTyp, Filectrl,
  ComCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    AbZipper1: TAbZipper;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    ListBox1: TListBox;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    Panel3: TPanel;
    BitBtn4: TBitBtn;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    BitBtn3: TBitBtn;
    SpeedButton1: TSpeedButton;
    Shape1: TShape;
    PopupMenu1: TPopupMenu;
    ClearAll1: TMenuItem;
    RemoveSelectedListItem1: TMenuItem;
    About1: TMenuItem;
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ClearAll1Click(Sender: TObject);
    procedure RemoveSelectedListItem1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function UniqTempFile(BaseDir, Prefix: string): string;
var
  X: string;
  SR: TSearchRec;
  IsFound: Boolean;
  i: Int64;
begin
  i := 10000;

  BaseDir := IncludeTrailingPathDelimiter(BaseDir);
  repeat
    IsFound := FindFirst(Basedir + Prefix + '-' + IntToStr(i) + '*', faAnyFile - faDirectory, SR) = 0;
    X := Basedir + Prefix + '-' + IntToStr(i);
    i := i + 1;
  until not IsFound;

  Result := X;

end;

procedure FindFiles(FilesList: TStringList; StartDir, FileMask: string);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
begin
  if not DirectoryExists(StartDir) then
    exit;

  StartDir := IncludeTrailingPathDelimiter(StartDir);

  { Build a list of the files in directory StartDir
     (not the directories!)                         }

  IsFound := FindFirst(StartDir + FileMask, faAnyFile - faDirectory, SR) = 0;
  while IsFound do
    begin
      FilesList.Add(StartDir + SR.Name);
      IsFound := FindNext(SR) = 0;
    end;
  FindClose(SR);

  // Build a list of subdirectories
  DirList := TStringList.Create;
  IsFound := FindFirst(StartDir + '*', faAnyFile, SR) = 0;
  while IsFound do
    begin
      if ((SR.Attr and faDirectory) <> 0) and
        (SR.Name[1] <> '.') then
        DirList.Add(StartDir + SR.Name);
      IsFound := FindNext(SR) = 0;
    end;
  FindClose(SR);

  // Scan the list of subdirectories
  for i := 0 to DirList.Count - 1 do
    FindFiles(FilesList, DirList[i], FileMask);

  DirList.Free;
end;


function MyFileSize(FileName: string): Int64;
var
  SearchRec: TSearchRec;
begin
  if FindFirst(FileName, faAnyFile, SearchRec) = 0 then // if found
     // calculate the size
    Result := Int64(SearchRec.FindData.nFileSizeHigh) shl Int64(32) + Int64(SearchREc.FindData.nFileSizeLow)
  else
    Result := 0;
  FindClose(SearchRec); // close the find
end;

function FormatByteSize(const bytes: Longint): string;
//function FormatByteSize(const bytes:double): string;
const
  B = 1; //byte
  KB = 1024 * B; //kilobyte
  MB = 1024 * KB; //megabyte
  GB = 1024 * MB; //gigabyte
begin
  if bytes > GB then
    result := FormatFloat('#.## GB', bytes / GB)
  else if bytes > MB then
    result := FormatFloat('#.## MB', bytes / MB)
  else if bytes > KB then
    result := FormatFloat('#.## KB', bytes / KB)
  else
    result := FormatFloat('#.## bytes', bytes);
end;

function IsStrANumber(const S: string): boolean;
var
  P: PChar;
begin
  P := PChar(S);
  Result := False;
  while P^ <> #0 do
    begin
      if not (P^ in ['0'..'9']) then
        Exit;
      Inc(P);
    end;
  Result := True;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
  MaxSize, Biggest, SZ: Int64;
  AbZipper: TAbZipper;
  i, T, X, C: integer;
  sl: TStringList;
  FName, LargestFile, Mx, Lx, TmpNm: string;
begin
  if ((IsStrANumber(edit1.Text) = False) or (Edit1.Text = '')) then
    begin
      ShowMessage('Enter a valid number for maximum zip file size.');
      exit;
    end;

  if ListBox1.Items.Count = 0 then
    exit;

  if Not DirectoryExists( ExtractFileDir(Edit2.Text) ) then
  begin
      ShowMessage('Enter a valid prefix for saving.' + #13 + 'Click the "Prefix Save As" button to select directory and enter prefix.');
      exit;
    end;

  if ComboBox1.ItemIndex = 0 then
    MaxSize := StrToInt(Edit1.Text) * 1024 * 1024
  else
    MaxSize := StrToInt(Edit1.Text) * 1024;


  //if Shape1.Visible then Dir to Zip
  if Shape1.Visible then
  Begin
  StatusBar1.SimpleText := 'Examining..';

  sl := Tstringlist.Create;
  SetCurrentDir(ListBox1.Items[0]);
  FindFiles(sl, '.\', '*');


 //Find the biggest file to see if this is already greater than maxsize
  Biggest := 0;
  for i := 0 to sl.Count - 1 do
    begin
      FName := sl[i];
      if MyFileSize(Fname) > Biggest then
        begin
          Biggest := MyFileSize(Fname);
          LargestFile := FName;
        end;
    end;

  FName := UniqTempFile(GetEnvironmentVariable('TEMP'), 'Azip');
  FName := FName + '.zip';
  AbZipper := TAbZipper.Create(nil);
  AbZipper.FileName := FName;
  AbZipper.AddFiles(LargestFile, 0);
  AbZipper.Save;
  AbZipper.CloseArchive;
  AbZipper.Free;
  AbZipper := nil;
  Biggest := MyFileSize(FName);
  DeleteFile(Fname);

  if Biggest > MaxSize then
    begin
      Mx := FormatByteSize(MaxSize);
      Lx := FormatByteSize(Biggest);
      ShowMessage('File named "' + LargestFile + '" is bigger [compressed] than the Maximum size.' + #13 + 'Maximum Size : ' + Mx + #13 + 'Size of compressed ' + LargestFile + ' : ' + Lx + #13 + #13 + 'Increase Maximum size or remove the ' + LargestFile);
      StatusBar1.SimpleText := '';
      Exit;
    end;

 //Biggest check ends

  StatusBar1.SimpleText := '';
  T := 0;
  X := 0;
  C := 0;
  SZ:=0;

  repeat
    C := C + 1;
    AbZipper := TAbZipper.Create(nil);
    FName := Edit2.Text + IntToStr(C) + '.zip';
    If FileExists(FName) Then DeleteFile(FName);
    TmpNm := FName + 'po';
    AbZipper.AutoSave:=True;
    AbZipper.FileName := FName;

    AbZipper.StoreOptions := [soStripDrive];

    for i := T to sl.Count - 1 do
      begin
        DeleteFile(TmpNm);
        if FileExists(FName) then
        begin
        CopyFile(Pchar(FName), PChar(TmpNm), True);
        SZ:= MyFileSize(TmpNm)
        end
        else
        SZ:=0;

        StatusBar1.SimpleText := IntTostr(i+1) + ' ' + sl[i];
        if SZ < MaxSize then
          begin
            AbZipper.AddFiles(sl[i], 0);
          end
          else
          begin
            X := i;
            Break;
          end;

            (*Error producing
        if MyFileSize(TmpNm) > MaxSize then
          begin
            Repeat
            if X = 0 then
            X := i
            else
            X := X-1;
            AbZipper.DeleteFiles(sl[X]);
            DeleteFile(TmpNm);
            StatusBar1.SimpleText:= inttostr(X);
            CopyFile(Pchar(FName), PChar(TmpNm), True);
            Until MyFileSize(TmpNm) <= MaxSize;
            Break;
          end;
          *)
      end;


    T := X;

    AbZipper.CloseArchive;
    AbZipper.Free;
    AbZipper := nil;
    DeleteFile(TmpNm);
    form1.Caption:= Inttostr(C) + '. Size: ' + FormatByteSize(SZ);
    Application.ProcessMessages;
  until (i = sl.Count);

  sl.Free;
  ShowMessage('ok');
  StatusBar1.SimpleText := 'End. Right click and select Clear All.';
  Exit;
  End;  //if Shape1.Visible then Dir to Zip

 //Shape1 not visible collect individual files to zip [copy all from above just change abzipper store option]
  StatusBar1.SimpleText := 'Examining..';

  sl := Tstringlist.Create;
  sl.Assign(ListBox1.Items);

  ShowMessage(inttostr(sl.Count));
 //Find the biggest file to see if this is already greater than maxsize
  Biggest := 0;
  for i := 0 to sl.Count - 1 do
    begin
      FName := sl[i];
      if MyFileSize(Fname) > Biggest then
        begin
          Biggest := MyFileSize(Fname);
          LargestFile := FName;
        end;
    end;

  FName := UniqTempFile(GetEnvironmentVariable('TEMP'), 'Azip');
  FName := FName + '.zip';
  AbZipper := TAbZipper.Create(nil);
  AbZipper.FileName := FName;
  AbZipper.AddFiles(LargestFile, 0);
  AbZipper.Save;
  AbZipper.CloseArchive;
  AbZipper.Free;
  AbZipper := nil;
  Biggest := MyFileSize(FName);
  DeleteFile(Fname);

  if Biggest > MaxSize then
    begin
      Mx := FormatByteSize(MaxSize);
      Lx := FormatByteSize(Biggest);
      ShowMessage('File named "' + LargestFile + '" is bigger [compressed] than the Maximum size.' + #13 + 'Maximum Size : ' + Mx + #13 + 'Size of compressed ' + LargestFile + ' : ' + Lx + #13 + #13 + 'Increase Maximum size or remove the ' + LargestFile);
      StatusBar1.SimpleText := '';
      Exit;
    end;

 //Biggest check ends

  StatusBar1.SimpleText := '';
  T := 0;
  X := 0;
  C := 0;
  SZ:=0;

  repeat
    C := C + 1;
    AbZipper := TAbZipper.Create(nil);
    FName := Edit2.Text + IntToStr(C) + '.zip';
    If FileExists(FName) Then DeleteFile(FName);
    TmpNm := FName + 'po';
    AbZipper.AutoSave:=True;
    AbZipper.FileName := FName;

    AbZipper.StoreOptions := [soStripDrive, soStripPath];//Just main changing

    for i := T to sl.Count - 1 do
      begin
        DeleteFile(TmpNm);
        if FileExists(FName) then
        begin
        CopyFile(Pchar(FName), PChar(TmpNm), True);
        SZ:= MyFileSize(TmpNm)
        end
        else
        SZ:=0;

        StatusBar1.SimpleText := IntTostr(i+1) + ' ' + sl[i];
        if SZ < MaxSize then
          begin
            AbZipper.AddFiles(sl[i], 0);
          end
          else
          begin
            X := i;
            Break;
          end;


      end;


    T := X;

    AbZipper.CloseArchive;
    AbZipper.Free;
    AbZipper := nil;
    DeleteFile(TmpNm);
    form1.Caption:= Inttostr(C) + '. Size: ' + FormatByteSize(SZ);
    Application.ProcessMessages;

  until (i = sl.Count);

  sl.Free;
  ShowMessage('ok');
  StatusBar1.SimpleText := 'End. Right click and select Clear All.';

(*
//AbZipper.StoreOptions := [soStripDrive, soStripPath];// store all file in root dir
 AbZipper.BaseDirectory:='C:\Users\Rabiul\Desktop\Aleem-Delphi-Tips-Bundle\';
 AbZipper.StoreOptions := [soRecurse];
 AbZipper.AddFiles('*', faReadOnly + faHidden);
 *)

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
if Shape1.Visible then
  if MessageDlg('Listbox has to be cleared for single file(s). Directory structure will not be kept in zip file.' + #13 + 'Proceed?', mtCustom, mbOKCancel, 0) = mrCancel then
   exit
   else
 begin
 ListBox1.Clear;
 shape1.Visible:=false;
 edit2.Clear;
 end;

  if Not OpenDialog1.Execute then Exit;
    ListBox1.Items.AddStrings(OpenDialog1.Files);

    //This is to create zip files that are split into smaller pieces of a specified size. Each small zip files can be extracted. This is intended to be used by users wants to upload files on remote server easily.
  if edit2.Text = '' then
  Edit2.Text:= IncludeTrailingPathDelimiter(ExtractFileDir(ListBox1.Items[ListBox1.items.count-1])) + 'MyFile-';
  if Shape1.Visible then
   shape1.Visible:=False;

end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  SendMessage(Listbox1.Handle, LB_SetHorizontalExtent, 1000, Longint(0));
{ This code came from Lloyd's help file! }
end;


procedure TForm1.BitBtn2Click(Sender: TObject);
var
  dir: string;
  i: Integer;

begin
if ListBox1.Items.Count > 0 then
    if MessageDlg('This will clear present list.' + #13 + 'Proceed?', mtCustom, mbOKCancel, 0) = mrCancel then
       exit;

  if not SelectDirectory('', '', Dir) then //Prevdir Makes trouble here
    exit;

  dir := IncludeTrailingPathDelimiter(Dir);
  
  Edit2.Text:= Dir + 'MyFile-';
  SetCurrentDir(Dir);
  ListBox1.Clear;
  ListBox1.Items.Add(Dir);
  if not Shape1.Visible then
  shape1.Visible:=True;
  (*
//  sl: TStringList;
  sl := Tstringlist.Create;
  FindFiles(sl, '.\', '*');
  ListBox1.Items.AddStrings(sl);
  sl.Free;
  *)
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
if not SaveDialog1.Execute then exit;
edit2.Text:= SaveDialog1.FileName;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
SpeedButton1.Align:=alBottom;
end;

procedure TForm1.ClearAll1Click(Sender: TObject);
begin

ListBox1.Clear;
Form1.Caption:= 'Akhir Split Zip 1.0';
StatusBar1.SimpleText:='';
shape1.Visible:= False;
Edit1.Text:= '1';
ComboBox1.ItemIndex:=0;
Edit2.Clear;

end;

procedure TForm1.RemoveSelectedListItem1Click(Sender: TObject);
begin
if ListBox1.Items.Count = 0 then exit;
ListBox1.SetFocus;
ListBox1.DeleteSelected;
ListBox1.ItemIndex:=ListBox1.Items.Count-1;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 ShowMessage('' + #13 +
             'In the name of Allah the Merciful the Beneficent.' + #13 +
             'Peace be upon Muhammad.' + #13 +
             '' + #13 +
             'Akhir Split Zip 1.0' + #13 +
             'Freeware.' + #13 +
             '' + #13 +
             'Rabiul Hassan Khan.' + #13 +
             'mail: rabiul_prkp85@yahoo.com' + #13 +
             'Chittagong, Bangladesh.' + #13 +
             '' );

end;

end.

